#ifndef LCF_SOFTMAX_H_
#define LCF_SOFTMAX_H_
#include "tensorOperate.h"

class SoftMaxLayer : public TensorOperate
{
    public:
        SoftMaxLayer();
        SoftMaxLayer(int ifType, int iID, int iMaxSeqNum, DevicesBatchDisptach *iDevicesBatchDisptach);
        void SetLayerConfig(int ifType, int iID, int iMaxSeqNum, DevicesBatchDisptach *iDevicesBatchDisptach);
        virtual ~SoftMaxLayer();
        void ComputeAndCreateOutYInDTensorInfo();
        void CreateParaAndInstance();
        void CompuateOutY(int devID, int seqNum);
        void CompuateOutD(int devID, int seqNum);

        void ComputerYMemRealease(int devID);
        void ComputerDMemRealease(int devID);

    private:
        void SetChildLayerMomeryPointInitStatus();
        float mWCoff, mBias;
        int inChannels, inHeight, inWidth;
        int outChannels, outHeight, outWidth;
};

#endif
